import * as React from 'react';
import { DocumentIdentifier } from '.';
import { Action } from './store';
/**
 * Represents a boolean value
 * @param initialValue
 */
export declare function boolean(initialValue?: boolean): (__0_0: boolean | undefined, __0_1: boolean | undefined, __0_2: (value: boolean | ((currentValue: boolean | undefined) => boolean)) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: boolean;
    value: boolean;
    set: (value: boolean | ((currentValue: boolean) => boolean)) => void;
};
/**
 * Represents a string value
 * @param initialValue
 */
export declare function string(initialValue?: string): (__0_0: string | undefined, __0_1: string | undefined, __0_2: (value: string | ((currentValue: string | undefined) => string)) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: string;
    value: string;
    set: (value: string | ((currentValue: string) => string)) => void;
};
/**
 * Represents a number value
 * @param initialValue
 */
export declare function number(initialValue?: number): (__0_0: number | undefined, __0_1: number | undefined, __0_2: (value: number | ((currentValue: number | undefined) => number)) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: number;
    value: number;
    set: (value: number | ((currentValue: number) => number)) => void;
};
/**
 * Represents a sub document
 */
export declare function child(options?: {
    plugin?: string;
    state?: string;
}): (__0_0: DocumentIdentifier | undefined, __0_1: {
    $$typeof: "@edtr-io/document";
    id: string;
} | undefined, __0_2: (value: {
    $$typeof: "@edtr-io/document";
    id: string;
} | ((currentValue: {
    $$typeof: "@edtr-io/document";
    id: string;
} | undefined) => {
    $$typeof: "@edtr-io/document";
    id: string;
})) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: DocumentIdentifier;
    value: {
        id: string;
        plugin?: string | undefined;
    };
    render: () => React.ReactNode;
};
/**
 * Represents a value of type T
 * @param initialValue
 */
export declare function scalar<T>(initialValue: T): (__0_0: T | undefined, __0_1: T | undefined, __0_2: (value: T | ((currentValue: T | undefined) => T)) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: T;
    value: T;
    set: (value: T | ((currentValue: T) => T)) => void;
};
/**
 * Represents a value of type T that the editor persists as a value of type S
 * @param initialValue
 * @param serializer
 */
export declare function serializedScalar<T, S = T>(initialValue: T, serializer: {
    deserialize: (value: S) => T;
    serialize: (value: T) => S;
}): (__0_0: T | undefined, __0_1: S | undefined, __0_2: (value: S | ((currentValue: S | undefined) => S)) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: S;
    value: T;
    set: (value: T | ((currentValue: T) => T)) => void;
};
export interface WrappedListElement<S> {
    value: S;
    id: string;
}
/**
 * Represents a list
 * @param type state descriptor for the elements of the list
 * @param initialCount initial length of the list
 */
export declare function list<D extends PluginStateDescriptor>(type: D, initialCount?: number): (__0_0: PluginStateDescriptorValueType<D>[] | undefined, __0_1: WrappedListElement<PluginStateDescriptorInternalValueType<D>>[] | undefined, __0_2: (value: WrappedListElement<PluginStateDescriptorInternalValueType<D>>[] | ((currentValue: WrappedListElement<PluginStateDescriptorInternalValueType<D>>[] | undefined) => WrappedListElement<PluginStateDescriptorInternalValueType<D>>[])) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: WrappedListElement<PluginStateDescriptorInternalValueType<D>>[];
    items: PluginStateDescriptorReturnType<D>[];
    insert: (index: number) => void;
    remove: (index: number) => void;
};
/**
 * Represents an object
 * @param types state descriptors for the properties of the object
 */
export declare function object<Ds extends Record<string, PluginStateDescriptor>>(types: Ds): (__0_0: PluginStateDescriptorsValueType<Ds> | undefined, __0_1: PluginStateDescriptorsSerializedValueType<Ds> | undefined, __0_2: (value: PluginStateDescriptorsSerializedValueType<Ds> | ((currentValue: PluginStateDescriptorsSerializedValueType<Ds> | undefined) => PluginStateDescriptorsSerializedValueType<Ds>)) => void, __0_3: (actions: Action[]) => void) => {
    $$insert: () => Action[];
    $$value: PluginStateDescriptorsSerializedValueType<Ds>;
    value: PluginStateDescriptorsReturnType<Ds>;
};
export declare type PluginStateDescriptor<T = any, S = T, R extends {
    $$value: S;
    $$insert: () => Action[];
} = any> = (...args: PluginStateParameters<T, S>) => R;
export declare type PluginStateParameters<T, S> = [T | undefined, S | undefined, (value: S | ((currentValue: S | undefined) => S)) => void, (actions: Action[]) => void];
export declare type PluginStateDescriptorValueType<D extends PluginStateDescriptor> = D extends PluginStateDescriptor<infer T, any> ? T : never;
export declare type PluginStateDescriptorInternalValueType<D extends PluginStateDescriptor> = D extends PluginStateDescriptor<any, infer S> ? S : never;
export declare type PluginStateDescriptorReturnType<D extends PluginStateDescriptor> = D extends PluginStateDescriptor<any, any, infer R> ? R : never;
export declare type PluginStateDescriptorsValueType<Ds extends Record<string, PluginStateDescriptor>> = {
    [K in keyof Ds]: PluginStateDescriptorValueType<Ds[K]> | undefined;
};
export declare type PluginStateDescriptorsSerializedValueType<Ds extends Record<string, PluginStateDescriptor>> = {
    [K in keyof Ds]: PluginStateDescriptorInternalValueType<Ds[K]> | undefined;
};
export declare type PluginStateDescriptorsReturnType<Ds extends Record<string, PluginStateDescriptor>> = {
    [K in keyof Ds]: PluginStateDescriptorReturnType<Ds[K]>;
};
//# sourceMappingURL=plugin-state.d.ts.map