import * as React from 'react';
import { PluginStateDescriptorReturnType, PluginStateParameters } from './plugin-state';
export declare type Plugin<S extends (...args: PluginStateParameters<any, any>) => any = () => void> = StatelessPlugin | StatefulPlugin<S>;
export interface StatelessPlugin {
    Component: React.ComponentType<StatelessPluginEditorProps>;
}
export interface StatefulPlugin<S extends (...args: PluginStateParameters<any, any>) => any> {
    Component: React.ComponentType<StatefulPluginEditorProps<S>>;
    state: S;
}
export interface StatefulPluginEditorProps<S extends (...args: PluginStateParameters<any, any>) => any> extends StatelessPluginEditorProps {
    state: PluginStateDescriptorReturnType<S>;
}
export interface StatelessPluginEditorProps {
    editable?: boolean;
    focused?: boolean;
}
export declare function isStatefulPlugin<S extends (...args: PluginStateParameters<any, any>) => any = () => void>(plugin: Plugin<S>): plugin is StatefulPlugin<S>;
export declare function isStatelessPlugin<S extends (...args: PluginStateParameters<any, any>) => any = () => void>(plugin: Plugin<S>): plugin is StatelessPlugin;
//# sourceMappingURL=plugin.d.ts.map